use std::collections::HashMap;
use crate::common::parse_input_file;

pub(crate) fn task2() -> usize {
    let (first_number_array, second_number_array) = parse_input_file();
    let mut map = HashMap::<usize, usize>::with_capacity(first_number_array.len());

    first_number_array
        .into_iter()
        .map(|value| {
            if let Some(product) = map.get(&value) {
                *product
            } else {
                let count = count_occurrences(&second_number_array, value);
                let product = value * count;
                map.insert(value, product);
                product
            }
        })
        .sum()
}

fn count_occurrences(array: &[usize], value: usize) -> usize {
    array
        .iter()
        .filter(|arr_value| **arr_value == value)
        .count()
}