use crate::common::parse_input;

pub(crate) fn task2() {
    let raw_input = include_str!("./input.txt");

    let mut safe_levels = 0;
    for mut level in parse_input(raw_input).into_iter() {
        if level.safe_by_removing() {
            safe_levels += 1; 
        }
    }
    println!("The solution to task 2 is {safe_levels}")
}

#[cfg(test)]
mod tests {
    use crate::common::Level;
    use crate::task1_alt::{LevelState, State};

    #[test]
    fn test_from_level() {
        let level = Level(vec![1, 3, 4, 5]);
        assert_eq!(
            [
                State::Stable,
                State::Increase(2),
                State::Increase(1),
                State::Increase(1)
            ],
            *LevelState::from(level).0
        )
    }
}
