use crate::common::parse_input;

pub(crate) fn task1() {
    let raw_input = include_str!("./input.txt");
    let (_remaining, products) = parse_input(raw_input).unwrap();

    // 191183308
    println!(
        "The solution to task 1 is {}",
        products.iter().sum::<usize>()
    )
}

#[cfg(test)]
mod tests {
    use crate::common::parse_input;

    #[test]
    fn test_task1() {
        let test_string = "xmul(2,4)%&mul[3,7]!@^do_not_mul(5,5)+mul(32,64]then(mul(11,8)mul(8,5))";
        let (remaining, products) = parse_input(test_string).unwrap();
        let sum = products.iter().sum();

        assert_eq!(")", remaining);
        assert_eq!(161usize, sum);
    }
}
