use crate::common::Parser;

pub(crate) fn task2() {
    let raw_input = include_str!("./input.txt");

    let mut parser = Parser::new();
    let (_remaining, _) = parser.parse(raw_input).unwrap();

    println!("The solution to task 2 is {}", parser.sum())
}

#[cfg(test)]
mod tests {
    use crate::common::Parser;

    #[test]
    fn test_task2() {
        let test_string =
            "xmul(2,4)&mul[3,7]!^don't()_mul(5,5)+mul(32,64](mul(11,8)undo()?mul(8,5))";
        let mut parser = Parser::new();
        let (_remaining, _) = parser.parse(test_string).unwrap();

        assert_eq!(48usize, *parser.sum())
    }
}
